<?php 
	include_once ("../../dap-config.php");
	include_once ("authenticationHeaderAdminAjax.php");
	
	$responseArray = array();
	$html = "";
  
	if ( isset($_GET['whatRequest']) && ($_GET['whatRequest'] != "") ) {
		$whatRequest = $_GET['whatRequest'];
		$responseArray['whatRequest'] = $whatRequest;
	}
	
	$emailId = trim(urldecode($_GET['emailId']));
	$productId = trim(urldecode($_GET['productId']));
	
	try {

		$user = Dap_User::loadUserByEmail($emailId);
		if(isset($user)) {
			$userId=$user->getId();
		}
		else {
		  $response="<p style='font-size:12px;color:red;'><strong>Sorry, no such user found in DAP. Please check the Entered Email Id.</strong></p>";	
		  $responseArray['responseJSON'] = $response;
		  $responseJSON = json_encode($responseArray);
		  echo $responseJSON;
		  return;
		}
		
		logToFile("autoresponderEmailStatusAjax: user=" . $userId . ", prod=". $productId); 
			
			
		$hasAccess = $user->hasAccessTo($productId);
		if (!$hasAccess) {
			 $response="<p style='font-size:14px;color:red;'><strong>Sorry, the user=" . $emailId . " currently does not have access to this product=". $productId . ". Please check DAP Users->Manage page and make sure the user has access to this product. The autoresponder email will only be sent to eligible users of the product. </strong></p>";
			// $response="Sorry, user does not have access to this product";
			 $responseArray['responseJSON'] = $response;
			 $responseJSON = json_encode($responseArray);
			 echo $responseJSON;
			 return;
		}
		
		$dapcron = new Dap_Cron();
		
		$lastrundapcron=$dapcron->didCronRun("dap-cron");
		logToFile("autoresponderEmailStatusAjax.php cron status: " . $lastrundapcron,LOG_DEBUG_DAP);
		
		if($lastrundapcron==FALSE) {
			 $response="<p style='font-size:14px;color:red;'><strong>The autoresponder emails are sent when the DAP Hourly CRON Runs. It appears that the DAP Hourly CRON is not running on your site. Please login to your Webhost CPanel => CRON Tab and make sure you find /dap/dap-cron.php set to run once every hour at the top of the hour. <br><br>
			 You can use our EASY INSTALLER PLUGIN to find out the CRON COMMAND for your site.  
			 <a target='_blank' href='http://digitalaccesspass.com/doc/dap-easy-installer'> Click here </a> to access the easy installer document.</strong></p>";
			// $response="Sorry, user does not have access to this product";
			 $responseArray['responseJSON'] = $response;
			 $responseJSON = json_encode($responseArray);
			 echo $responseJSON;
			 return;	
		}
		
		$html = "1) The autoresponder emails are sent when the DAP Hourly CRON Runs. CRON looks good. No cron issues found.  <br><br>The last time the cron ran was at " . $lastrundapcron;
		
		//Checkdripday
		$userProduct = Dap_UsersProducts::load($userId, $productId);
		
	//	$active_days = $userProduct->getActiveDays();
		
		if($userProduct != NULL) {
			//check user eligibility to receive the autoresponderemails
			$isEligible=$userProduct->isUserEligible($userId,$productId);
			
			if(!$isEligible) {
				$response="<p style='font-size:14px;color:red;'>Sorry, the user=" . $emailId . " is not eligible to receive any emails dripped under this product (productId=".$productId."). <br><br>Please check DAP Users->Manage page and make sure the user has access to this product. The autoresponder email will only be sent to eligible users of the product. <br><br>
				
				These are the eligibility rules: <br><br> 
				
				1) The user status should be 'A' (active). Check Users=>Manage page to find this user's status. <br> <br>
				2) The user's product status should be 'A' (active). Check Users=>Manage page to find user's status to this product. <br> <br>
				3) The user should NOT have opted-out of emails. Check Users=>Manage page to see if user has opted out. <br> <br>
				4) The user access should not have expired. Check Users=>Manage page to see if the user's access end date is in future and NOT in the past. <br>
				
				</p>";
			// $response="Sorry, user does not have access to this product";
			   $responseArray['responseJSON'] = $response;
			   $responseJSON = json_encode($responseArray);
			   echo $responseJSON;
			   return;
			}
			
			//$active_days = $userProduct->getActiveDays();
			$today =  date("Y-m-d",time());
			$access_start_date =  $userProduct->getAccess_start_date();
			
			logToFile("(autoresponderEmailStatusAjax.php: user->product active Days: ".$today);
			logToFile("(autoresponderEmailStatusAjax.php: user->product active Days: ".$access_start_date);
						
			$asd = strtotime($access_start_date);
			$t = strtotime($today);
			
			$active_days =(  ($t - $asd)/(3600*24) ) + 1;
						
				
			logToFile("(autoresponderEmailStatusAjax.php: user->product active Days: ".$active_days);
		}
		else {
			$response="<p style='font-size:14px;color:red;'><strong>Sorry, the user=" . $emailId . " does not seem to have access to this product=". $productId . ". Please check DAP Users->Manage page and make sure the user has access to this product. The autoresponder email will only be sent to eligible users of the product. </strong></p>";
			// $response="Sorry, user does not have access to this product";
			 $responseArray['responseJSON'] = $response;
			 $responseJSON = json_encode($responseArray);
			 echo $responseJSON;
			 return;
		}
		
		
		
		if($active_days==1) {
			$html .= "<br><br>2) This user is on day " . $active_days . " of membership to this product.<br><br>";
			$html .= "The user (" . $emailId . ") signed up to the product (productId=".$productId. ") today. If a new user signs up, they will receive the  autoresponder emails that are set to drip on day 1 when the DAP hourly crons runs.
		  <br><br>
		  Say the user signed up at 6:30 AM today morning, then all the autoresponder emails that you have set to drip day 1 would have been  sent when the cron ran next (@ 7:00 AM).";
		  
			$html .= "This user should have received the following email(s) set to drip on day " . $active_days . " under this product :<br><br>";
		}
		else {
			$html .= "<br><br>2) This user is on day " . $active_days . " of membership to this product.";
			$html .= "This user is an existing member of this product. <br><br>
		  Say you have an email set to drip day 7.<br>
		  
		  When a user reaches day 7 of membership to the product, the cron will send out the day 7 email at midnight that day (because that's when the cron will run for the first time for that day).<br><br>
		  
		  If a user did not receive an email, it could be because the CRON failed to run or because you have email delivery issues.
		  <br><br>";
		  
		  $html .= "Today when the cron ran at midnight (server time), it would have attempted to send the following email(s) set to drip on day " . $active_days . " under this product :<br><br>";
		}
		
		$product = Dap_Product::loadProduct($productId);
		
		$html .= $product->displayAssignedEmailResourcesUsingDripDay ($productId, $active_days);
	
	
	} catch (PDOException $e) {
		$html = ERROR_GENERAL;
	} catch (Exception $e) {
		$html = ERROR_GENERAL;
	}
	
	$responseArray['responseJSON'] = "<p style='font-size:14px;'>".$html."</p>";
	$responseJSON = json_encode($responseArray);
	echo $responseJSON;
		
?>