<?php 
	include_once ("../../dap-config.php");
	include_once ("authenticationHeaderUserAjax.php");
	header('Content-type: text/html; charset=UTF-8') ;
	
if(isset($_GET['operation_name']) && $_GET['operation_name'] == 'saveUpdatePaymentSettings'){
	
	$responseArray = array();
	$response = "";
	
	
	$send_email = $_GET['send_email'];
	$email_body = $_GET['email_body'];
	$email_subject = $_GET['email_subject'];
	$payment_processor = $_GET['payment_processor'];
	$type = $_GET['notification_type'];
	
	
	$failedPaymentSettings = new DAP_FailedPaymentSettings();
	
	$failedPaymentSettings->setPaymentProcessor($payment_processor);
	$failedPaymentSettings->setTransactionType($type);
	$failedPaymentSettings->setSubject($email_subject);
	$failedPaymentSettings->setBody(urldecode($email_body));
	
	
		
	$settingsAvailable = DAP_FailedPaymentSettings::loadByPaymentProcessorAndType($payment_processor, $type);
	if(isset($settingsAvailable)){
		$id = $settingsAvailable->getId();
		$sendAdminEmail = $settingsAvailable->getSendAdminEmail();
		$sendEmail = $settingsAvailable->getSendEmail();
		
		$failedPaymentSettings->setId($id);
		$failedPaymentSettings->setSendEmail($sendEmail);
		$failedPaymentSettings->setSendAdminEmail($sendAdminEmail);
		$failedPaymentSettings->update();
	}else{
		$failedPaymentSettings->setSendEmail($send_email);
		$failedPaymentSettings->setSendAdminEmail('N');
		$failedPaymentSettings->create();
	}

	$failedPaymentSettingsTable = getFailedPaymentTableData();

	echo json_encode($failedPaymentSettingsTable);die;


}else if(isset($_POST['operation_name']) && ($_POST['operation_name'] ==  'loadFailOrders')){
	
	include_once ("../../dap-config.php"); 
		 
	$startDateFilter = isset($_POST['startDateFilter']) ? $_POST['startDateFilter'] : "";

	$startDateFilter = strtr($startDateFilter, '-', '/');
	$startDateFilter = new DateTime($startDateFilter);
	$startDateFilter = $startDateFilter->format('Y-m-d H:i:s');
	$output['startDateFilter'] = $startDateFilter;
	
	$endDateFilter = isset($_POST['endDateFilter']) ? $_POST['endDateFilter'].' 23:59:59' : "";
	$endDateFilter = strtr($endDateFilter, '-', '/');
	$endDateFilter = new DateTime($endDateFilter);
	$endDateFilter = $endDateFilter->format('Y-m-d H:i:s');
	
	$output['endDateFilter'] = $endDateFilter;
	
	$filter_option = isset($_POST['filter_option']) ? $_POST['filter_option'] : "";
	
	$userIdFilter = isset($_POST['userIdFilter']) ? $_POST['userIdFilter'] . "'": "";
	if($filter_option == 'email_option'){
		
		$emailFilter = isset($_POST['emailFilter']) ? $_POST['emailFilter'] : "";
		$user_obj = Dap_User::loadUserByEmail($emailFilter);
		if(isset($user_obj)){
			$userIdFilter = $user_obj->getId();
		}		
	}
	
	$productIdFilter = isset($_POST['productIdFilter']) ? $_POST['productIdFilter'] : "";
	
	$paymentProcessorFilter = isset($_POST['paymentProcessorFilter']) ?  $_POST['paymentProcessorFilter'] : "";
	
	$userFailedDetails  = DAP_UsersProductsFailedPayments::loadByFilter($userIdFilter, $productIdFilter, $startDateFilter, $endDateFilter, $paymentProcessorFilter);
	$html = '';
	if(isset($userFailedDetails)){
		  foreach($userFailedDetails as $details){
				$userId = $details->getUserId();
				$productId = $details->getProductId();
				$product = Dap_Product::loadProduct($productId);
				$user = Dap_User::loadUserById($userId);
				$email = '';
				if(isset($user)){
				$name = $user->getFirst_name();	
				$email = $user->getEmail();	
				}
				if(isset($product)){
				$product_name = $product->getName();		
				}
				if($email != ''){
				  
					$html  .= '<tr>';
					$html  .= '<td>'.$name.'</td>';
					$html  .= '<td>'.$email.'</td>';
					$html  .= '<td>';
					$html  .= '<div class="tool-tip">';
					$html  .= $product_name;
					$html  .= '<div class="toll-tip-desc">'.$product_name.'</div>';
					$html  .= '</div>';
					$html  .= '</td>';
					$html  .= '<td> ';
					$html  .= '<div class="tool-tip">';
					$html  .= $details->getReason();
					$html  .= '<div class="toll-tip-desc">'.$details->getReason().'</div>';
					$html  .= '</div>';
					$html  .= '</td>';
					$html  .= '<td>'.$details->getTransactionType().'</td> '; 
					$html  .= '<td>';
					$html  .= '<div class="status_td">';
					if($details->getAction() == 'Email Sent'){
						$html  .= '<i class="fa fa-check status_tick" aria-hidden="true"></i> <span>Sent <br><small>'.$details->getTransactionDate().'</small></span>';
					}else{
						$html  .= '<span>No Email Sent</span>';	
					}
					$html  .= '</div>';
					$html  .= '</td>';
					$html  .= '<td align="center" ><a title="Send Mail" user_id="'.$userId.'" product_id="'.$productId.'" href="javascript:void(0)" onclick="dapResendPaymentFailedMail(this)" ><i class="fa fa-envelope-o email_icon" aria-hidden="true"></i></a></td>';
					$html  .= '</tr>';
		
				} 
		 }
		}
	
	
	
	$output['html'] = $html;
	echo json_encode($output);
	die;
	
	
}else if(isset($_GET['operation_name']) && ($_GET['operation_name'] ==  'loadOrders')){
	include_once ("../../dap-config.php"); 
		
	$transactionId = isset($_GET['transactionId']) ? $_GET['transactionId'] : 0;
	$transNumFilter = isset($_GET['transNumFilter']) ? "'" . $_GET['transNumFilter'] . "'": "";
	$emailFilter = isset($_GET['emailFilter']) ?   trim($_GET['emailFilter']) : "";
	$productIdFilter = isset($_GET['productIdFilter']) ? $_GET['productIdFilter'] : "";
	$couponIdFilter = isset($_GET['couponIdFilter']) ? $_GET['couponIdFilter'] : "";
	$userIdFilter = isset($_GET['userIdFilter']) ? $_GET['userIdFilter'] . "'": "";
	$statusFilter = isset($_GET['statusFilter']) ? "'" . $_GET['statusFilter'] . "'": "";
	$displayFilter = isset($_GET['display_option']) ? "" . $_GET['display_option'] . "": "";
	$paymentProcessorFilter = isset($_GET['paymentProcessorFilter']) ?  $_GET['paymentProcessorFilter'] : "";
	$profileIdFilter = isset($_GET['profileIdFilter']) ?  $_GET['profileIdFilter'] : "";
	$stripeCustomerIdFilter = isset($_GET['stripeCustomerIdFilter']) ?  $_GET['stripeCustomerIdFilter'] : "";
	$spcButtonIdFilter = isset($_GET['spcButtonIdFilter']) ?  $_GET['spcButtonIdFilter'] : "";
	$payPerPostIdFilter = isset($_GET['payPerPostIdFilter']) ?  $_GET['payPerPostIdFilter'] : "";
	$filter_option = isset($_GET['filter_option']) ?  $_GET['filter_option'] : "";
	
	if($filter_option == 'pay_per_post'){
		$payPerPostIdFilter = $payPerPostIdFilter == '' ?  "all" : $payPerPostIdFilter;	
	}
	
	$endDefaultDate = date('m-d-Y');
	$startDefaultDate = date("m-d-Y", strtotime("-1 days", strtotime($endDefaultDate)));
	
	$endDate = isset($_GET['endDate']) ? "" . $_GET['endDate'] . "": $endDefaultDate;
	$startDate = isset($_GET['startDate']) ? "" . $_GET['startDate'] . "": $startDefaultDate;
	
	$allTransactions = loadTransactionsDisplayHTMLManageOrders($transNumFilter, $emailFilter, $productIdFilter, $statusFilter,$couponIdFilter,$userIdFilter, $startDate ,$endDate , $displayFilter, $paymentProcessorFilter, $profileIdFilter, $stripeCustomerIdFilter, $spcButtonIdFilter, $payPerPostIdFilter, $filter_option);
	
	echo $allTransactions;die;
}else if(isset($_GET['operation_name']) && $_GET['operation_name'] ==  'delete_failed_payment'){
	DAP_FailedPaymentSettings::delete($_GET['id']);
	echo 'success';die;
}else if(isset($_GET['operation_name']) && $_GET['operation_name'] ==  'updateSendEmail'){
	$id = $_GET['id'];
	$type = $_GET['emailType'];
	$status = $_GET['status'];
	DAP_FailedPaymentSettings::updateEmail($id, $type, $status);
}
