<?php

$sql_ddl[] = "ALTER TABLE `dap_aff_comm` 
	ADD `per_lead_fixed_credits` INT( 11 ) NULL AFTER `per_sale_percentage` ,
	ADD `per_sale_fixed_credits` INT( 11 ) NULL AFTER `per_lead_fixed_credits`,
	ADD `per_sale_percentage_credits` INT( 11 ) NULL AFTER `per_sale_fixed_credits`
";

$sql_ddl[] = "ALTER TABLE `dap_aff_payments` ADD `earning_type` VARCHAR( 7 ) NOT NULL DEFAULT 'CASH'";
$sql_ddl[] = "ALTER TABLE `dap_aff_payments` DROP INDEX `affiliate_id`";
$sql_ddl[] = "ALTER TABLE `dap_aff_payments` ADD UNIQUE `affiliate_id` (`affiliate_id`,`aff_exports_id`,`earning_type`)";

$sql_ddl[] = "INSERT INTO `dap_config` (
		`id` ,
		`name` ,
		`value` ,
		`description` ,
		`editable` ,
		`type` ,
		`values` ,
		`display_order` ,
		`category` 
	)
	VALUES 
	(NULL , 'SEND_AFF_EMAIL_SALE', 'N', 'Send Affiliate Notification Email for Sales?', 'Y', 'html_select', 'Y|N', '99', 'advanced'	),
	(NULL , 'SEND_AFF_EMAIL_LEAD', 'N', 'Send Affiliate Notification Email for Leads?', 'Y', 'html_select', 'Y|N', '99', 'advanced'	),
	(NULL , 'WP_DISABLE_SYNC_EXP', 'N', 'Disable Syncing for Expired Users', 'Y', 'html_select', 'Y|N', '14', 'advanced'),
	(NULL , 'FLUSH_IP_HOW_OFTEN', 'Week', 'How often to flush login IP records', 'Y', 'html_select', 'Never|Day|Week|2 Weeks|Month|', '14', 'advanced'),
	(NULL , 'LAST_FLUSH_DATE', CURDATE() , 'Date when login history last flushed', 'N', 'html_text', '', '14', 'advanced'),
	(NULL , 'POST_UNSUB_URL', '/dap/unsubscribed.php' , 'URL to redirect to, after unsubscribing', 'Y', 'html_text', '', '14', 'advanced'),
	(NULL , 'AFF_COOKIE_LENGTH', '365', 'Length of Affiliate Cookie', 'Y', 'html_text', '', '99', 'advanced'),
	(NULL , 'FIRST_LAST_COOKIE', 'Last-Cookie', 'First-Cookie or Last-Cookie wins?', 'Y', 'html_select', 'Last-Cookie|First-Cookie', '99', 'advanced'),
	(NULL , 'RENEWAL_REDIR_URL', '', 'Global Renewal Redirect URL', 'Y', 'html_text', '', '99', 'advanced'	),
	(NULL , 'REDIR_TO_RENEW_URL', 'N', 'Should expired user be redirected to renewal URL?', 'Y', 'html_select', 'Y|N', '99', 'advanced'	)

";

$sql_ddl[] = "ALTER TABLE `dap_custom_fields` ADD `required` CHAR( 1 ) NOT NULL DEFAULT 'N'";

$sql_ddl[] = "ALTER TABLE `dap_products` ADD `recurring_credits` INT( 10 ) NULL DEFAULT '0' AFTER `allow_free_signup`";
$sql_ddl[] = "ALTER TABLE `dap_products` ADD `product_image_url_linkedto` VARCHAR( 100 ) NULL AFTER `recurring_credits` ";
$sql_ddl[] = "ALTER TABLE `dap_products` ADD `short_description` VARCHAR( 127 ) NULL AFTER `product_image_url_linkedto` ";
$sql_ddl[] = "ALTER TABLE `dap_products` ADD `long_description` TEXT NULL AFTER `short_description` ";
$sql_ddl[] = "ALTER TABLE `dap_products` ADD `resell_product` CHAR( 1 ) NOT NULL DEFAULT 'N' AFTER `self_service_allowed` ";
$sql_ddl[] = "ALTER TABLE `dap_products` ADD `access_expiration_action` VARCHAR( 100 ) NULL DEFAULT 'NOACTION' AFTER `long_description`";
$sql_ddl[] = "ALTER TABLE `dap_products` ADD `renewal_redirect_url` VARCHAR( 100 ) NULL , ADD `renewal_html` TEXT NULL";

$sql_ddl[] = "ALTER TABLE `dap_products_resources_jn` ADD `file_resource_id` INT( 11 ) NULL DEFAULT '0' AFTER `display_order` ";
$sql_ddl[] = "ALTER TABLE `dap_products_resources_jn` ADD `pay_per_post` DECIMAL( 7, 2 ) NULL DEFAULT '0.00' AFTER `file_resource_id`";

$sql_ddl[] = "INSERT INTO `dap_templates` 
	(
		`id` ,
		`name` ,
		`description` ,
		`category` ,
		`content` 
	)
	VALUES 
	(NULL , 'AUTOMATED_AUTORESPONDER_EMAIL_CONTENT', 'Email: Automated Email Dripping', 'email', 'This email will be dripped automatically when new content %%CONTENT_ID%% is dripped'),
	(NULL , 'AFF_NOTIF_LEAD_SUBJ', 'Email: Affiliate Notification Subject (LEAD)', 'email', 'You Have A New Lead!'),
	(NULL , 'AFF_NOTIF_LEAD_BODY', 'Email: Affiliate Notification Body (LEAD)', 'email', '%%FIRST_NAME%%,
	
You have sent us a new lead at
%%SITE_URL_DAP%%

Product: %%PRODUCT_NAME%%
Amount Earned: %%AMOUNT_EARNED%%

If there is a sale or lead commission involved, it will be processed within the next couple of hours, and any commissions earned will be credited to your affiliate account.

NOTE: All commissions are subject to review and possible changes.

You may view your affiliate stats at:
%%SITE_URL_DAP%%

Thank you for your support!

- %%ADMIN_NAME%%
%%SITE_URL_DAP%%'
),
	(NULL , 'AFF_NOTIF_SALE_SUBJ', 'Email: Affiliate Notification Subject (SALE)', 'email', 'You Have Earned A Commission!'),
	(NULL , 'AFF_NOTIF_SALE_BODY', 'Email: Affiliate Notification Body (SALE)', 'email', '%%FIRST_NAME%%,
	
You have sent us a new buyer at
%%SITE_URL_DAP%%

Product: %%PRODUCT_NAME%%
Amount Earned: %%AMOUNT_EARNED%%

NOTE: All commissions are subject to review and possible changes.

Commissions will be processed within the next couple of hours and credited to your affiliate account.

You may view your affiliate stats at:
%%SITE_URL_DAP%%

Thank you for your support!

- %%ADMIN_NAME%%
%%SITE_URL_DAP%%'
)";


$sql_ddl[] = "ALTER TABLE `dap_transactions` ADD `user_id` INT( 11 ) DEFAULT NULL AFTER `product_id`";
$sql_ddl[] = "ALTER TABLE `dap_transactions` CHANGE `trans_num` `trans_num` VARCHAR( 30 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '0'";

$sql_ddl[] = "ALTER TABLE `dap_users` ADD `exclude_iplogging` CHAR( 1 ) NOT NULL DEFAULT 'N'"; 
$sql_ddl[] = "ALTER TABLE `dap_users` CHANGE `password` `password` VARCHAR(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT ''";

$sql_ddl[] = "ALTER TABLE `dap_users_credits` CHANGE `comments` `comments` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL"; 
$sql_ddl[] = "TRUNCATE TABLE dap_users_logins";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(30) NOT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8
";

$sql_ddl[] = "INSERT INTO `dap_category` (`code`, `description`) VALUES
('New In Fiction', 'New in Fiction'),
('Top Sellers', 'Top Sellers')
";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_products_category_jn` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `category_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `productcategorykey` (`product_id`,`category_id`),
  KEY `product_id` (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_credits` (
  `userid` int(11) NOT NULL,
  `type` varchar(100) NOT NULL,
  `used` int(11) NOT NULL,
  `postid` bigint(20) NOT NULL,
  `title` varchar(300) DEFAULT NULL,
  `credits` int(11) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_forum_priority` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `target_usergroupId` int(11) NOT NULL,
  `priority` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `uniqueindex` (`target_usergroupId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";



//this should always be the last update
$sql_ddl[] = "UPDATE `dap_config` SET `value` = '4.4' WHERE  `name` = 'DAP_VERSION_CLIENT'  LIMIT 1";


?>