<?php
 
class DAP_PayUsingCredits {
	
   	var $id;
   	var $page_id;
   	var $product_id;
   	var $status;
   	var $button_html;
   	var $button_customizer_values;
   	var $resource_id;
   	var $redeem_action_type;
   	var $redeem_redirect_url;
   	var $button_type;
   	var $image_src;
   	var $redeem_url;
   	var $date; 
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
    
    function getPageId() {
		return $this->page_id;
	}
	function setPageId($o) {
		$this->page_id = $o;
	}
	
	function getProductId() {
		return $this->product_id;
	}
	function setProductId($o) {
		$this->product_id = $o;
	}
    
    function getStatus() {
		return $this->status;
	}
	function setStatus($o) {
		$this->status = $o;
	}
	
	function getButtonHtml() {
		return $this->button_html;
	}
	function setButtonHtml($o) {
		$this->button_html = $o;
	}
	
	function getButtonCustomizerValues() {
		return $this->button_customizer_values;
	}
	function setButtonCustomizerValues($o) {
		$this->button_customizer_values = $o;
	}
	
	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}
	
	
	function getResourceId() {
		return $this->resource_id;
	}
	function setResourceId($o) {
		$this->resource_id = $o;
	}
	
	function getRedeemActionType() {
		return $this->redeem_action_type;
	}
	function setRedeemActionType($o) {
		$this->redeem_action_type = $o;
	}
	
	function getAfterRedeemRedirectUrl() {
		return $this->redeem_redirect_url;
	}
	function setAfterRedeemRedirectUrl($o) {
		$this->redeem_redirect_url = $o;
	}
	
	function getButtonType() {
		return $this->button_type;
	}
	function setButtonType($o) {
		$this->button_type = $o;
	}
	
	function getImageSrc() {
		return $this->image_src;
	}
	function setImageSrc($o) {
		$this->image_src = $o;
	}
	
	function getRedeemUrl() {
		return $this->redeem_url;
	}
	function setRedeemUrl($o) {
		$this->redeem_url = $o;
	}
	
	
	
	public function create() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_pay_using_credits
						(page_id, product_id, status, button_html, button_customizer_values, date, resource_id,redeem_after_redirect_url,redeem_action_type, button_type, image_src, redeem_url )
					values 
						(:page_id, :product_id, :status, :button_html, :button_customizer_values, now(), :resource_id, :redeem_after_redirect_url, :redeem_action_type, :button_type, :image_src, :redeem_url)";

          

			$stmt = $dap_dbh->prepare($sql);
				 
 
			
			$stmt->bindParam(':page_id', $this->getPageId(), PDO::PARAM_INT);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':button_html', $this->getButtonHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':button_customizer_values', $this->getButtonCustomizerValues(), PDO::PARAM_STR);
			$stmt->bindParam(':resource_id', $this->getResourceId(), PDO::PARAM_INT);
			$stmt->bindParam(':redeem_after_redirect_url', $this->getAfterRedeemRedirectUrl(), PDO::PARAM_STR);
			$stmt->bindParam(':redeem_action_type', $this->getRedeemActionType(), PDO::PARAM_STR);
			
			$stmt->bindParam(':button_type', $this->getButtonType(), PDO::PARAM_STR);
			
			$stmt->bindParam(':image_src', $this->getImageSrc(), PDO::PARAM_STR);
			$stmt->bindParam(':redeem_url', $this->getRedeemUrl(), PDO::PARAM_STR);
			
			
 			$stmt->execute();
			 
			$last_insert_id = $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
	
	public function update() {
		
		try {
			
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "update 
					dap_pay_using_credits
					set
						 page_id = :page_id, 
						 product_id = :product_id, 
						 status = :status, 
						 button_html = :button_html,
						 button_customizer_values = :button_customizer_values,
						 resource_id = :resource_id,
						 redeem_after_redirect_url= :redeem_after_redirect_url,
						 redeem_action_type = :redeem_action_type,
						 redeem_url = :redeem_url,
						 image_src = :image_src,
						 button_type = :button_type,
						 date=now()
						 where
						 id = :id";
			
			$stmt = $dap_dbh->prepare($sql);	

			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->bindParam(':page_id', $this->getPageId(), PDO::PARAM_INT);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_INT);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':button_html', $this->getButtonHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':button_customizer_values', $this->getButtonCustomizerValues(), PDO::PARAM_STR);
			
			$stmt->bindParam(':redeem_after_redirect_url', $this->getAfterRedeemRedirectUrl(), PDO::PARAM_STR);
			$stmt->bindParam(':redeem_action_type', $this->getRedeemActionType(), PDO::PARAM_STR);
			$stmt->bindParam(':redeem_url', $this->getRedeemUrl(), PDO::PARAM_STR);
			$stmt->bindParam(':image_src', $this->getImageSrc(), PDO::PARAM_STR);
			$stmt->bindParam(':button_type', $this->getButtonType(), PDO::PARAM_STR);
			$stmt->bindParam(':resource_id', $this->getResourceId(), PDO::PARAM_INT);
			
 			$stmt->execute();
			 
			$last_insert_id = $this->getId();
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
	
	static public function loadByPageId($page_id = 0) {
		
		try {
			
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "select * from 	dap_pay_using_credits where page_id =:page_id";
			$stmt = $dap_dbh->prepare($sql);	
			$stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
			
			
 			$stmt->execute();
			$data = null; 
			if ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				
				$data = new DAP_PayUsingCredits();
				$data->setId( $row["id"] );
				$data->setPageId( $row["page_id"] );
				$data->setProductId( $row["product_id"] );
				$data->setStatus( stripslashes($row["status"]) );
				$data->setButtonHtml( stripslashes($row["button_html"]) );
				$data->setResourceId( stripslashes($row["resource_id"]) );
				$data->setAfterRedeemRedirectUrl( stripslashes($row["redeem_after_redirect_url"]) );
				$data->setRedeemActionType( stripslashes($row["redeem_action_type"]) );
				$data->setRedeemUrl( stripslashes($row["redeem_url"]) );
				$data->setImageSrc( stripslashes($row["image_src"]) );
				$data->setButtonType( stripslashes($row["button_type"]) );  
				$data->setButtonCustomizerValues( stripslashes($row["button_customizer_values"]) );  
				
			} 
			$stmt = null;
			$dap_dbh = null;
			return $data;	
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	static public function loadByPageIdAndProductId($page_id = 0,$product_id = 0) {
		
		try {
			
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "select * from 	dap_pay_using_credits where page_id =:page_id and product_id = :product_id";
			$stmt = $dap_dbh->prepare($sql);	
			$stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
			$stmt->bindParam(':product_id', $product_id, PDO::PARAM_INT);
			
			
 			$stmt->execute();
			$data = null; 
			if ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				
				$data = new DAP_PayUsingCredits();
				$data->setId( $row["id"] );
				$data->setPageId( $row["page_id"] );
				$data->setProductId( $row["product_id"] );
				$data->setStatus( stripslashes($row["status"]) );
				$data->setButtonHtml( stripslashes($row["button_html"]) );
				$data->setResourceId( stripslashes($row["resource_id"]) );
				$data->setAfterRedeemRedirectUrl( stripslashes($row["redeem_after_redirect_url"]) );
				$data->setRedeemActionType( stripslashes($row["redeem_action_type"]) );
				$data->setRedeemUrl( stripslashes($row["redeem_url"]) );
				$data->setImageSrc( stripslashes($row["image_src"]) );
				$data->setButtonType( stripslashes($row["button_type"]) );  
				$data->setButtonCustomizerValues( stripslashes($row["button_customizer_values"]) );  
				
			} 
			$stmt = null;
			$dap_dbh = null;
			return $data;	
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	

	
}
