<?php
 
class DAP_PayUsingCreditsDetails {
	
   	var $id;
   	var $page_id;
   	var $msg_above;
   	var $msg_below;


	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
    
    function getPageId() {
		return $this->page_id;
	}
	function setPageId($o) {
		$this->page_id = $o;
	}
	
	function getMsgAbove() {
		return $this->msg_above;
	}
	function setMsgAbove($o) {
		$this->msg_above = $o;
	}
    
    function getMsgBelow() {
		return $this->msg_below;
	}
	function setMsgBelow($o) {
		$this->msg_below = $o;
	}
	
	
	
	
	
	
	
	
	
	
	public function create() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_pay_using_credits_details
						(page_id, msg_above, msg_below)
					values 
						(:page_id, :msg_above, :msg_below)";

			$stmt = $dap_dbh->prepare($sql);
				 
      
			
			$stmt->bindParam(':page_id', $this->getPageId(), PDO::PARAM_INT);
			$stmt->bindParam(':msg_above', $this->getMsgAbove(), PDO::PARAM_STR);
			$stmt->bindParam(':msg_below', $this->getMsgBelow(), PDO::PARAM_STR);
 			$stmt->execute();
			 
			$last_insert_id = $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
	
	public function update() {
		
		try {
			
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "update 
					dap_pay_using_credits_details
					set
						 page_id =:page_id, 
						 msg_above =:msg_above, 
						 msg_below =:msg_below 
						 where
						 id =:id ";
				 
			$stmt = $dap_dbh->prepare($sql);	

			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->bindParam(':page_id', $this->getPageId(), PDO::PARAM_INT);
			$stmt->bindParam(':msg_above', $this->getMsgAbove(), PDO::PARAM_STR);
			$stmt->bindParam(':msg_below', $this->getMsgBelow(), PDO::PARAM_STR);
			
			
 			$stmt->execute();
			 
			$last_insert_id = $this->getId();
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
	static public function loadByPageId($page_id = 0) {
		
		try {
			
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "select * from dap_pay_using_credits_details where page_id =:page_id";
				 
			$stmt = $dap_dbh->prepare($sql);	

			$stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
		
			
			
 			$stmt->execute();
			$data = null; 
			if ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new DAP_PayUsingCreditsDetails();
				$data->setId( $row["id"] );
				$data->setPageId( $row["page_id"] );
				$data->setMsgAbove( $row["msg_above"] );
				$data->setMsgBelow( stripslashes($row["msg_below"]) );
			} 
			$stmt = null;
			$dap_dbh = null;
			return $data;	
	
		} catch (PDOException $e) { 
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}

	
}
