<?php
class Dap_BuddyBossMapping {
	
	var $id;
	var $product_id;
	var $tag_id;	
	var $group_ids;	
	var $profiles;	
	var $action;	
	var $dest_action;	
	var $date;	
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getProductId() {
		return $this->product_id;
	}
	function setProductId($o) {
		$this->product_id = $o;
	}
	
	function getTagId() {
		return $this->tag_id;
	}
	function setTagId($o) {
		$this->tag_id = $o;
	}
	
	function getGroupIds() {
		return $this->group_ids;
	}
	function setGroupIds($o) {
		$this->group_ids = $o;
	}
	
	function getProfileIds() {
		return $this->profiles;
	}
	function setProfileIds($o) {
		$this->profiles = $o;
	}
	
	function getAction() {
		return $this->action;
	}
	function setAction($o) {
		$this->action = $o;
	}
	
	function getDestAction() {
		return $this->dest_action;
	}
	function setDestAction($o) {
		$this->dest_action = $o;
	}
	
	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "insert into dap_buddyboss_mapping
						(product_id, tag_id, group_ids, profiles, action, dest_action,date)
					values
						(:product_id, :tag_id, :group_ids, :profiles, :action, :dest_action, :date)";

			$stmt = $dap_dbh->prepare($sql);
			
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_STR);
			$stmt->bindParam(':tag_id', $this->getTagId(), PDO::PARAM_STR);
			$stmt->bindParam(':group_ids', $this->getGroupIds(), PDO::PARAM_STR);
			$stmt->bindParam(':profiles', $this->getProfileIds(), PDO::PARAM_STR);
			$stmt->bindParam(':action', $this->getAction(), PDO::PARAM_STR);
			$stmt->bindParam(':dest_action', $this->getDestAction(), PDO::PARAM_STR);
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->execute();

			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			
				$sql = "update dap_buddyboss_mapping set
							product_id = :product_id,
							tag_id = :tag_id, 
							profiles = :profiles, 
							group_ids = :group_ids,
							action = :action, 
							dest_action = :dest_action 
						    where id = :id";
			 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_STR);
			$stmt->bindParam(':tag_id', $this->getTagId(), PDO::PARAM_STR);
			$stmt->bindParam(':group_ids', $this->getGroupIds(), PDO::PARAM_STR);
			$stmt->bindParam(':profiles', $this->getProfileIds(), PDO::PARAM_STR);
			$stmt->bindParam(':action', $this->getAction(), PDO::PARAM_STR);
			$stmt->bindParam(':dest_action', $this->getDestAction(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
		
			return;

		} catch (PDOException $e) {
			echo $e->getMessage();die;
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			echo $e->getMessage();die;
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadByProductIdTypeAndAction($pId, $type, $action) {
		$sql = "select * from dap_buddyboss_mapping where product_id ='".$pId."'";
		
		if($type == 'group'){
			$sql .= " AND group_ids IS NOT NULL"; 		
		}else if($type == 'profile'){
			$sql .= " AND profiles IS NOT NULL"; 			
		}
		
		$sql .= " AND action = '".$action."'"; 		
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			$groupBBRules = false;
			$groupBBRulesArr = array();
			
			while ($row = $stmt->fetch()) {
				$groupBBRules = new Dap_BuddyBossMapping();

				$groupBBRules->setId( $row["id"] );
				$groupBBRules->setProductId($row["product_id"]);
				$groupBBRules->setTagId($row["tag_id"]);
				$groupBBRules->setGroupIds($row["group_ids"]);
				$groupBBRules->setProfileIds($row["profiles"]);
				$groupBBRules->setAction($row["action"]);
				$groupBBRules->setDestAction($row["dest_action"]);
				$groupBBRulesArr[] = $groupBBRules;
			}
			return $groupBBRulesArr;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		
	}
	
	public static function loadByProductIdTypeAndActionAndDestAction($pId, $type, $action, $dest_action) {
		$sql = "select * from dap_buddyboss_mapping where product_id ='".$pId."'";
		
		if($type == 'group'){
			$sql .= " AND group_ids IS NOT NULL"; 		
		}else if($type == 'profile'){
			$sql .= " AND profiles IS NOT NULL"; 			
		}
		
		$sql .= " AND action = '".$action."'"; 		
		$sql .= " AND dest_action = '".$dest_action."'"; 		
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			$groupBBRules = false;
			
			while ($row = $stmt->fetch()) {
				$groupBBRules = new Dap_BuddyBossMapping();

				$groupBBRules->setId( $row["id"] );
				$groupBBRules->setProductId($row["product_id"]);
				$groupBBRules->setTagId($row["tag_id"]);
				$groupBBRules->setGroupIds($row["group_ids"]);
				$groupBBRules->setProfileIds($row["profiles"]);
				$groupBBRules->setAction($row["action"]);
				$groupBBRules->setDestAction($row["dest_action"]);
			}
			return $groupBBRules;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		
	}
	
	public static function loadByTypeAndAction($type , $action, $groupBy = '') {
		 
		$sql = "select * from dap_buddyboss_mapping ";
		
		
		if($type == 'group'){
			$sql .= " WHERE group_ids IS NOT NULL"; 		
		}else if($type == 'profile'){
			$sql .= " WHERE profiles IS NOT NULL"; 			
		}
		$sql .= " AND action = '".$action."'"; 		
	
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			$buddyBossRulesList = array();
			
			while ($row = $stmt->fetch()) {
				$buddyBossRules = new Dap_BuddyBossMapping();

				$buddyBossRules->setId( $row["id"] );
				$buddyBossRules->setProductId($row["product_id"]);
				$buddyBossRules->setTagId($row["tag_id"]);
				$buddyBossRules->setGroupIds($row["group_ids"]);
				$buddyBossRules->setProfileIds($row["profiles"]);
				$buddyBossRules->setAction($row["action"]);
				$buddyBossRules->setDestAction($row["dest_action"]);
				$buddyBossRulesList[] = $buddyBossRules;
			}

			return $buddyBossRulesList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function load() {
		 
		$sql = "select * from dap_buddyboss_mapping ";
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			$buddyBossRulesList = array();
			
			while ($row = $stmt->fetch()) {
				$buddyBossRules = new Dap_BuddyBossMapping();

				$buddyBossRules->setId( $row["id"] );
				$buddyBossRules->setProductId($row["product_id"]);
				$buddyBossRules->setTagId($row["tag_id"]);
				$buddyBossRules->setGroupIds($row["group_ids"]);
				$buddyBossRules->setProfileIds($row["profiles"]);
				$buddyBossRules->setAction($row["action"]);
				$buddyBossRules->setDestAction($row["dest_action"]);
				$buddyBossRulesList[] = $buddyBossRules;
			}

			return $buddyBossRulesList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public function delete($id) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$dap_dbh->beginTransaction();
			
			  $sql = "delete from  
					dap_buddyboss_mapping
					where id =:id"; 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
			
			$dap_dbh->commit(); 
			
			$stmt = null;
			$dap_dbh = null;		
			return;			
		} catch (PDOException $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;				
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;			
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}		
	}
	
	
}
