<?php
 
class Dap_EmailNotification {
	
   	var $id;
   	var $user_id;
   	var $email_sent;
   	var $notification_type;
   	var $date; 
   	var $resent_date; 
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	function getUserId() {
		return $this->user_id;
	}
	function setUserId($o) {
		$this->user_id = $o;
	}
	
	function getEmailSent() {
		return $this->email_sent;
	}
	function setEmailSent($o) {
		$this->email_sent = $o;
	}

	function getNotificationType() {
		return $this->notification_type;
	}
	function setNotificationType($o) {
		$this->notification_type = $o;
	}	 
	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}
	function getResentDate() {
		return $this->resent_date;
	}
	function setResentDate($o) {
		$this->resent_date = $o;
	}
 	
	public function create() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			logToFile("(Dap_EmailNotification.class.php create() .");	
			$sql = "insert into dap_emailnotification
						( user_id, email_sent, notification_type, date, resent_date)
					values 
						(:user_id,  :email_sent, :notification_type, now(), :resent_date)";

			$stmt = $dap_dbh->prepare($sql);				 
 
			$stmt->bindParam(':user_id', $this->getUserId(), PDO::PARAM_INT);
			$stmt->bindParam(':email_sent', $this->getEmailSent(), PDO::PARAM_STR);
			$stmt->bindParam(':notification_type', $this->getNotificationType(), PDO::PARAM_STR); 
			$stmt->bindParam(':resent_date', $this->getResentDate(), PDO::PARAM_STR); 
 			$stmt->execute();
			 
						logToFile("(Dap_EmailNotification.class.php create() after.");	
			$last_insert_id = $dap_dbh->lastInsertId();
	 
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
 
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
	
			$sql = "update 
					dap_emailnotification
					set
						 user_id =:user_id, 
						 email_sent =:email_sent,  
						 notification_type=:notification_type,
						 date=now(),
						 resent_date=:resent_date,
					where
						id =:id ";
					
			$stmt = $dap_dbh->prepare($sql);	
			
			$stmt->bindParam(':user_id', $this->getUserId(), PDO::PARAM_INT);
			$stmt->bindParam(':email_sent', $this->getEmailSent(), PDO::PARAM_STR);
			$stmt->bindParam(':notification_type', $this->getNotificationType(), PDO::PARAM_STR); 
			$stmt->bindParam(':resent_date', $this->getResentDate(), PDO::PARAM_STR); 
			$stmt->execute();
			
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
 
	public static function loadSendMailDistinctUsersList() {
		$dataarr = array();
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						user_id,id,email_sent,date, notification_type,  resent_date 
					FROM
						dap_emailnotification order by id desc";
						
			//logToFile($sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			 
			$stmt->execute();
	
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_EmailNotification();
 
				$data->setId( stripslashes($row["id"]) );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setEmailSent( stripslashes($row["email_sent"]) );
				$data->setNotificationType( stripslashes($row["notification_type"]) );
				$data->setDate( stripslashes($row["date"]) ); 
				$data->setResentDate( stripslashes($row["resent_date"]) ); 
				$dataarr[] = $data;

			}
			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	}
	
	 public static function loadByUserId($user_id) {
		$dataarr = NULL;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_emailnotification
					WHERE
						user_id =:user_id 
					order by id desc
					limit 1
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_EmailNotification();
				
				$data->setId( stripslashes($row["id"]) );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setEmailSent( stripslashes($row["email_sent"]) );
				$data->setNotificationType( stripslashes($row["notification_type"]) );
				$data->setDate( stripslashes($row["date"]) );  
				$data->setResentDate( stripslashes($row["resent_date"]) ); 
				$dataarr = $data;

			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	  
	public static function loadById($id) {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_emailnotification
					WHERE
						id =:id 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
	        if ($row = $stmt->fetch()) {
				$data = new Dap_EmailNotification();
				$data->setId( stripslashes($row["id"]) );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setEmailSent( stripslashes($row["email_sent"]) );
				$data->setNotificationType( stripslashes($row["notification_type"]) );
				$data->setDate( stripslashes($row["date"]) ); 
				$data->setResentDate( stripslashes($row["resent_date"]) ); 
				$dataarr = $data;

			}
			$stmt = null;
			$dap_dbh = null;
			return $dataarr;				
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		 
	} 
	
	public static function loadByIdUID($user_id) {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_emailnotification
					WHERE
						user_id =:user_id 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
			$stmt->execute();
	        if ($row = $stmt->fetch()) {
				$data = new Dap_EmailNotification();
				$data->setId( stripslashes($row["id"]) );
				
				return  $data;

			}
			$stmt = null;
			$dap_dbh = null;
			 	return $dataarr;
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		 
	} 
	
	public static function load() {
		$dataarr = array();
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_emailnotification ";
						
			//logToFile($sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			 
			$stmt->execute();
	
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_EmailNotification();
 
				$data->setId( stripslashes($row["id"]) );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setEmailSent( stripslashes($row["email_sent"]) );
				$data->setNotificationType( stripslashes($row["notification_type"]) );
				$data->setDate( stripslashes($row["date"]) );
				$data->setResentDate( stripslashes($row["resent_date"]) );  
				$dataarr[] = $data;

			}
			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
 
}
 
