<?php
	
class Dap_GopUserBadgeActionEligible {
	
   	var $id;
   	var $user_id;
   	var $badge_id;
   	var $action;
   	var $date_earned; 
   	var $value; 
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	function getUserId() {
		return $this->user_id;
	}
	function setUserId($o) {
		$this->user_id = $o;
	}
	function getBadgeId() {
		return $this->badge_id;
	}
	function setBadgeId($o) {
		$this->badge_id = $o;
	}
	function getAction() {
		return $this->action;
	}
	function setAction($o) {
		$this->action = $o;
	}

	function getDateEarned() {
		return $this->date_earned;
	}
	function setDateEarned($o) {
		$this->date_earned = $o;
	}
	 function getValue() {
		return $this->value;
	}
	function setValue($o) {
		$this->value = $o;
	}
	 
	 
	 
	
	public function create() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_gop_user_badge_action_eligible
						( user_id, badge_id, action,value, date_earned)
					values 
						( :user_id, :badge_id, :action, :value, now())";

			$stmt = $dap_dbh->prepare($sql);
				 
 
			$stmt->bindParam(':user_id', $this->getUserId(), PDO::PARAM_INT);
			$stmt->bindParam(':badge_id', $this->getBadgeId(), PDO::PARAM_INT);
			$stmt->bindParam(':value', $this->getValue(), PDO::PARAM_STR);
			$stmt->bindParam(':action', $this->getAction(), PDO::PARAM_STR);
			
 			$stmt->execute();
			 
			$last_insert_id = $dap_dbh->lastInsertId();
	 
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
 
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
	
			$sql = "update 
					dap_gop_user_badge_action_eligible
					set
						 user_id =:user_id, 
						 badge_id =:badge_id, 
						 value =:value ,
						 action =:action 
					where
						id = :id ";
					
			$stmt = $dap_dbh->prepare($sql);	
			
			$stmt->bindParam(':user_id', $this->getUserId(), PDO::PARAM_INT);
			$stmt->bindParam(':badge_id', $this->getBadgeId(), PDO::PARAM_INT);
			$stmt->bindParam(':action', $this->getAction(), PDO::PARAM_STR);
			$stmt->bindParam(':value', $this->getValue(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->execute();
			
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
 
	public static function load() {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_gop_user_badge_action_eligible ORDER BY date DESC
					";
			//logToFile($sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			 
			$stmt->execute();
	
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_GopUserBadgeActionEligible();
				$data->setId( stripslashes($row["id"]) );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setBadgeId( stripslashes($row["badge_id"]) );
				$data->setAction( stripslashes($row["action"]) );
				$data->setValue( stripslashes($row["value"]) );
				$data->setDateEarned( stripslashes($row["date_earned"]) );
				$dataarr[] = $data;

			}
			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	}
	public static function loadByUserID($user_id) {
		$dataarr = array();
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			  $sql = "SELECT 
						*
					FROM
						dap_gop_user_badge_action_eligible WHERE
						user_id =:user_id 
					";
			 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
			$stmt->execute();
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {				 
				$data = new Dap_GopUserBadgeActionEligible();
				$data->setId( stripslashes($row["id"]) );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setBadgeId( stripslashes($row["badge_id"]) );
				$data->setAction( stripslashes($row["action"]) );
				$data->setValue( stripslashes($row["value"]) );
				$data->setDateEarned( stripslashes($row["date_earned"]) );
				$dataarr[] = $data;
			}
			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	}
	
	 public static function loadById($id = 0) {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_gop_user_badge_action_eligible
					WHERE
						id =:id 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_GopUserBadgeActionEligible();
				$data->setId( stripslashes($row["id"]) );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setBadgeId( stripslashes($row["badge_id"]) );
				$data->setAction( stripslashes($row["action"]) );
				$data->setDateEarned( stripslashes($row["date_earned"]) );
				$data->setValue( stripslashes($row["value"]) );
			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	 public static function loadByActionAndBadgeIdAndUserId($action = 0, $badge_id = 0, $user_id = 0) {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_gop_user_badge_action_eligible
					WHERE
						action =:action And
						badge_id =:badge_id And
						user_id =:user_id  
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':action', $action, PDO::PARAM_STR);
			$stmt->bindParam(':badge_id', $badge_id, PDO::PARAM_INT);
			$stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_GopUserBadgeActionEligible();
				$data->setId( stripslashes($row["id"]) );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setBadgeId( stripslashes($row["badge_id"]) );
				$data->setAction( stripslashes($row["action"]) );
				$data->setDateEarned( stripslashes($row["date_earned"]) );
				$data->setValue( stripslashes($row["value"]) );
				$dataarr = $data;
			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
	
	public static function delete($id = 0) {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sql = "delete from dap_gop_user_badge_action_eligible where id = :id";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_INT);
		$stmt->execute();

		return $id;
	}
 
}
