<?php
 
class Dap_NotificationsMaster {
	
   	var $id;
   	var $type;
   	var $name;
   	var $value;
   	var $date; 
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	function getType() {
		return $this->type;
	}
	function setType($o) {
		$this->type = $o;
	}	
	function getName() {
		return $this->name;
	}
	function setName($o) {
		$this->name = $o;
	}
	function getValue() {
		return $this->value;
	}
	function setValue($o) {
		$this->value = $o;
	}	 
	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}
 	
	public function create() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_notifications_master
						( type, name, value, date)
					values 
						(:type, :name, :value, now())";

			$stmt = $dap_dbh->prepare($sql);				 
 				

			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
			$stmt->bindParam(':name', $this->getName(), PDO::PARAM_STR);
			$stmt->bindParam(':value', $this->getValue(), PDO::PARAM_STR); 
 			$stmt->execute();
			
			$last_insert_id = $dap_dbh->lastInsertId();
	 
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
 
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
	
			$sql = "update 
					dap_notifications_master
					set
						 value=:value,
						 date=now()
					where
						name =:name and type=:type";
					
			$stmt = $dap_dbh->prepare($sql);	
			
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
			$stmt->bindParam(':name', $this->getName(), PDO::PARAM_STR);
			$stmt->bindParam(':value', $this->getValue(), PDO::PARAM_STR);  
			$stmt->execute();
			
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}	 
	
	 public static function loadByType($type) {
		$dataarr = NULL;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_notifications_master
					WHERE
						type =:type 		 
					";

			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':type', $type, PDO::PARAM_STR);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_NotificationsMaster();				
				$data->setId( stripslashes($row["id"]) );
				$data->setType( stripslashes($row["type"]) );
				$data->setName( stripslashes($row["name"]) );
				$data->setValue( stripslashes($row["value"]) );
				$data->setDate( stripslashes($row["date"]) );  
				$dataarr = $data;

			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
	 public static function loadByNameAndType($name, $type) {
		$dataarr = NULL;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_notifications_master
					WHERE
						name =:name  AND		 
						type =:type 		 
					";
				
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':name', $name, PDO::PARAM_STR);
			$stmt->bindParam(':type', $type, PDO::PARAM_STR);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				
				$data = new Dap_NotificationsMaster();				
				$data->setId( stripslashes($row["id"]) );
				$data->setType( stripslashes($row["type"]) );
				$data->setName( stripslashes($row["name"]) );
				$data->setValue( stripslashes($row["value"]) );
				$data->setDate( stripslashes($row["date"]) );  
				$dataarr = $data;


			}	
			return $dataarr;
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			//logToFile($e->getMessage(),LOG_FATAL_DAP);
			//throw $e;
		} catch (Exception $e) {
			//logToFile($e->getMessage(),LOG_FATAL_DAP);
			//throw $e;
		}
		
		
	} 
	  
	public static function loadById($id) {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_notifications_master
					WHERE
						id =:id 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
	        if ($row = $stmt->fetch()) {
				$data = new Dap_NotificationsMaster();
				$data->setId( stripslashes($row["id"]) );
				$data->setType( stripslashes($row["type"]) );
				$data->setName( stripslashes($row["name"]) );
				$data->setValue( stripslashes($row["value"]) );
				$data->setDate( stripslashes($row["date"]) );  
				$dataarr = $data;

			}
			$stmt = null;
			$dap_dbh = null;
			return $dataarr;				
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
 
}
 
