<?php

class maropost {

   function maropost() // constructor
   {
   }

   //======== USER REGISTRATION / UPDATE / DELETE ========
	// Add if user not there,  else update 
	function register($userId, $productId, $params)
	{
		$dapver=floatval(DAP_VERSION);
		if($dapver<4.6) {
			logToFile("maropost: integration not supported", LOG_DEBUG_DAP);
			return;
		}
		logToFile("maropost.class.php: register(): calling storeAddress", LOG_INFO_DAP);
		
		$this->storeAddress($userId, $productId, $params);
	}
		
	function storeAddress($userId, $productId, $params){
		
		$dapuser = Dap_User::loadUserById($userId);
		$email = trim($dapuser->getEmail());
		$username = trim($dapuser->getUser_name());
		$firstname = trim($dapuser->getFirst_name());
		$lastname = trim($dapuser->getLast_name());
		$password = $dapuser->getPassword();
		$city = $dapuser->getCity();
		$address1 = $dapuser->getAddress1();
		$address2 = $dapuser->getAddress2();
		$state = $dapuser->getState();
		$zip = $dapuser->getZip();
		$country = $dapuser->getCountry();
		$phone = $dapuser->getPhone();
		
		// Added by Veena - Retrieve Custom Fields for the user - 11/19/11
		$customfieldlist = Dap_API::loadCustomFieldsForUser($dapuser);
		if(isset($customfieldlist) && ($customfieldlist != NULL) && ($customfieldlist != "")) {
		  foreach ($customfieldlist as $key=>$val) {
		   // $key is the name of the field and $val is the value of the custom field
			logToFile("maropost.class.php:key=value: " . $key . "=" . $val, LOG_INFO_DAP);
		  }
		}
		// End custom field retrieval
		
		$data = explode(":",$params);
		
		$authToken=$data[1];
		$accountId=$data[2];
		$listId=$data[3];
		
		
		logToFile("maropost.class.php: storeAddress(): email =" . $email, LOG_INFO_DAP);
		
		if(!preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*$/i", $email)) {
			logToFile("maropost.class.php: storeAddress(): invalid email", LOG_INFO_DAP);
			return "Email address is invalid"; 
		}
	
		$postfields = array();

		try {
			$form_data = array(
				'first_name'       => trim($firstname),
				'last_name'          => trim($lastname),
				'email'           => trim($email),
				'phone'         => trim($phone)
			);
			logToFile("maropost.class.php: $action(): create contact", LOG_INFO_DAP);
		} catch (PDOException $e) {
			logToFile("maropost.class.php: $action(): user details can't be retrieved ".$e->getMessage(), LOG_INFO_DAP);
			return "user details can't be retrieved";
		} catch (Exception $e) {
			logToFile("maropost.class.php: $action(): user details can't be retrieved ".$e->getMessage(), LOG_INFO_DAP);
			return "user details can't be retrieved";
		}
		
	//	foreach ($form_data as $f => $v) {
		//	logToFile("maropost.class.php: $action(): data: $f = $v", LOG_INFO_DAP);
			//$postfields[] = $f.'='.$v;
		//}
		
		//$form_url="http://api.maropost.com/accounts/XX/lists/:list_id/contacts";
		//$endpoint='lists/' . $listId . '/contacts';
		
		logToFile("maropost.class.php: str=".$str, LOG_INFO_DAP);
		
	//	$url_api = "http://api.maropost.com/accounts/$accountId/";
		 
		//$url = $url_api . $endpoint . ".json";
		//$form_data['auth_token'] = $authToken;
		
		//$url="http://api.maropost.com/accounts/4/lists/4423/contacts";
		//$form_data['auth_token'] = "398565ca46f56edadecf52c6f0d941122d92b21b";
		
		
		$params = "auth_token=" . $authToken . "&subscribed=true&contact[email]=" . trim($email) . "&custom_field[country]=" . $country . "&contact[first_name]=" . trim($firstname) . "&contact[last_name]=" . array_pop(trim($lastname)) . "&custom_field[zip_or_postal_code]=" . $zip;

		$url = "http://api.maropost.com/accounts/" . $accountId . "/lists/" . $listId . "/contacts.json";
		
		logToFile("maropost.class.php: params=".$params, LOG_INFO_DAP);
		logToFile("maropost.class.php: url=".$url, LOG_INFO_DAP);
		
		$ch = curl_init($url);
	  
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		// send the request
		$response = curl_exec($ch);
		// check http status code
		$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		if ($http_code != 201) {
		  //throw new Exception('Response Http Error - ' . $response);
		  logToFile("maropost.class.php:Response Http Error : http_code=" . $http_code, LOG_INFO_DAP);
		  $err="maropost.class.php:Response Http Error=" . $http_code;
		  return $err;
		}
		// check for curl error
		if (0 < curl_errno($ch)) {
			$err='Unable to connect to ' . $url . ' Error: ' . curl_error($ch);
			logToFile("maropost.class.php:Response Http Error : " . $err, LOG_INFO_DAP);
			return $err;
		 // throw new Exception('Unable to connect to ' . $url . ' Error: ' . curl_error($ch));
		}
		// close the connection
		curl_close($ch);
		
		$response = json_decode($response, true);
	    $contact_id = $response['id'];

		logToFile("maropost.class.php: added successfully to maropost. contact_id : " . $contact_id, LOG_INFO_DAP);
		return 0;
	}
	
	
	function unregister($userId, $productId, $params)
	{
		$dapver=floatval(DAP_VERSION);
		if($dapver<4.6) {
			logToFile("maropost: integration not supported", LOG_DEBUG_DAP);
			return;
		}
		
		logToFile("maropost.class.php: register(): calling storeAddress", LOG_INFO_DAP);
		
		$this->removeAddress($userId, $productId, $params);
	}
	
	
	function removeAddress($userId, $productId, $params){
		
		$dapuser = Dap_User::loadUserById($userId);
		$email = trim($dapuser->getEmail());
		
		$data = explode(":",$params);
				
		$authToken=$data[1];
		$accountId=$data[2];
		$listId=$data[3];
		
		logToFile("maropost.class.php: removeAddress(): email =" . $email, LOG_INFO_DAP);
		
		if(!preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*$/i", $email)) {
			logToFile("maropost.class.php: storeAddress(): invalid email", LOG_INFO_DAP);
			return "Email address is invalid"; 
		}
	
		//$params = "auth_token=" . urlencode(trim($authToken)) . "&contact[email]=" . urlencode(trim($email));
		
		//http://api.maropost.com/accounts/4/contacts/email.json?auth_token=398565ca46f56edadecf52c6f0d941122d92b21b&contact[email]=veenatest1@webmasterinabox.net
		//$url = "http://api.maropost.com/accounts/" . $accountId . "/contacts/email.xml?contact[email]=" . $email . "&auth_token=" . $authToken;
		$params = "auth_token=" . trim($authToken);
		//$url = "http://api.maropost.com/accounts/" . $accountId . "/contacts/email.json?contact[email]=" . trim($email);
		
		$url = "http://api.maropost.com/accounts/" . $accountId . "/contacts/email.json?contact[email]=" . trim($email) . "&auth_token=" . $authToken;
		
		logToFile("maropost.class.php: removeAddress(): url =" . $url, LOG_INFO_DAP);
		//logToFile("maropost.class.php:removeAddress(): fetch contact info:url=" . $url . "?auth_token=" . $authToken . "&contact[email]=" . trim($email), LOG_INFO_DAP);
		
//		http://api.maropost.com/accounts/4/contacts/email.xml?contact[email]=veena@digitalaccesspass.com&auth_token=398565ca46f56edadecf52c6f0d941122d92b21b 
		$ch = curl_init($url);
	  
		//curl_setopt($ch, CURLOPT_POST, 1);
		//curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		// send the request
		$response = curl_exec($ch);
		// check http status code
		$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		if ($http_code > 201) {
		  //throw new Exception('Response Http Error - ' . $response);
		  logToFile("maropost.class.php:removeAddress(): fetch contact info: Response Http Error : http_code=" . $http_code, LOG_INFO_DAP);
		  $err="maropost.class.php:Response Http Error=" . $http_code;
		  return $err;
		}
		// check for curl error
		if (0 < curl_errno($ch)) {
			$err='Unable to connect to ' . $url . ' Error: ' . curl_error($ch);
			logToFile("maropost.class.php:removeAddress(): fetch contact info: Response Http Error : " . $err, LOG_INFO_DAP);
			return $err;
		 // throw new Exception('Unable to connect to ' . $url . ' Error: ' . curl_error($ch));
		}
		// close the connection
		curl_close($ch);
		
		$response = json_decode($response, true);
	    $contact_id = $response['id'];
	
		logToFile("maropost.class.php:removeAddress(): contact_id FOUND = " . $contact_id, LOG_INFO_DAP);
		
		logToFile("maropost.class.php:removeAddress(): now remove contact=$contact_id from list=".$listId, LOG_INFO_DAP);
		$params = "auth_token=" . $authToken;
		
	//	$url = "http://api.maropost.com/accounts/" . $accountId . "/lists/" . $listId . "/contacts/" . $contact_id . ".json?" . $params;
		$url = "http://api.maropost.com/accounts/" . $accountId . "/lists/" . $listId . "/contacts/" . $contact_id . ".json";
		
		$ch = curl_init($url);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		//curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		// send the request
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "DELETE");
		$response = curl_exec($ch);
		// check http status code
		$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		if ( ($http_code != 201) && ($http_code != 200) ) {
		  //throw new Exception('Response Http Error - ' . $response);
		  logToFile("maropost.class.php:removeFromList: Response Http Error : http_code=" . $http_code, LOG_INFO_DAP);
		  $err="maropost.class.php:removeFromList: Response Http Error=" . $http_code;
		  return $err;
		}
		// check for curl error
		if (0 < curl_errno($ch)) {
			$err='Unable to connect to ' . $url . ' Error: ' . curl_error($ch);
			logToFile("maropost.class.php:removeFromList: Response Http Error : " . $err, LOG_INFO_DAP);
			return $err;
		 // throw new Exception('Unable to connect to ' . $url . ' Error: ' . curl_error($ch));
		}
		// close the connection
		curl_close($ch);
		
		$response = json_decode($response, true);
	    $contact_id = $response['id'];

		logToFile("maropost.class.php: removeFromList: removed successfully from maropost. contact_id : " . $contact_id, LOG_INFO_DAP);
		return 0;
	}
			
} 
?>